package com.example.myaccelerometer

import android.content.Context
import android.hardware.Sensor
import android.hardware.SensorManager
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.hardware.SensorEvent
import android.hardware.SensorEventListener
import android.widget.TextView
import android.widget.Toast


/*
    Note below the addition of SensorEventListener
    to the usual
    class MainActivity : AppCompatActivity() {
    giving
    class MainActivity : AppCompatActivity(), SensorEventListener {
*/
class MainActivity : AppCompatActivity(), SensorEventListener {

    private lateinit var sensorManager: SensorManager
    private lateinit var my_accelerometer: Sensor
    private lateinit var tvX: TextView
    private lateinit var tvY: TextView
    private lateinit var tvZ: TextView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        tvX = findViewById<TextView>(R.id.tvX)
        tvY = findViewById<TextView>(R.id.tvY)
        tvZ = findViewById<TextView>(R.id.tvZ)

        this.sensorManager = getSystemService(Context.SENSOR_SERVICE) as SensorManager
        my_accelerometer = sensorManager!!.getDefaultSensor(Sensor.TYPE_ACCELEROMETER)

    }//end onCreate

    //****************************************************************************************************************
    override fun onResume(){
        super.onResume()
        sensorManager!!.registerListener(this, my_accelerometer, SensorManager.SENSOR_DELAY_NORMAL)
    } //end onResume

    //****************************************************************************************************************
    override fun onPause(){
        super.onPause()
        sensorManager!!.unregisterListener(this)
    }//end onPause

    //*****************************************************************************************************************
    override fun onSensorChanged(event: SensorEvent?) {

        when (event?.sensor?.type) {
            Sensor.TYPE_ACCELEROMETER -> {
                tvX.text = "X: "+event!!.values[0]
                tvY.text = "Y: "+event!!.values[1]
                tvZ.text = "Z: "+event!!.values[2]
            }
        }

    }//end onSensorChanged

    //*****************************************************************************************************************
    override fun onAccuracyChanged(sensor: Sensor?, accuracy: Int) {
        //…
    }

}//end MainActivity

